/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.jobnet.classes;

import org.apache.log4j.Logger;

import com.sos.i18n.I18NBase;
import com.sos.i18n.annotation.I18NResourceBundle;

/**
* \class Status 
* 
* \brief Status - 
* 
* \details
*
* \section Status.java_intro_sec Introduction
*
* \section Status.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id: Status.java 19375 2013-03-09 17:53:38Z ss $
* \see reference
*
* Created on 22.02.2012 16:59:13
 */

@I18NResourceBundle(baseName = "com_sos_jobnet_messages", defaultLocale = "en")
public class Status extends I18NBase {
	private final String		conClassName		= "Status";
	@SuppressWarnings("unused")
	private	final String		conSVNVersion		= "$Id: Status.java 19375 2013-03-09 17:53:38Z ss $";
	@SuppressWarnings("unused")
	private static final Logger	logger				= Logger.getLogger(Status.class);
	private static final String	I18NMsgPrefix		= "JNETSTAT_T_000";
	

	public Status() {
		super(JobNetConstants.strBundleBaseName);
	}
	
	/* 0 = not processed, 1 = running, 2 = finished, 3 = error, 4 = ignored, 5 = waiting, 6 = dispatching */
	public static enum enuStatus {
		NOT_PROCESSED(0), 
		RUNNING      (1), 
		FINISHED     (2),
		ERROR        (3),
		IGNORED      (4), 
		WAITING      (5),
		DISPATCHING  (6),
		STARTING  (7),
		STARTED (8),
		UNDEFINED(99);

		private int status = -1;

		private enuStatus(int status) {
            this.status = status;
        }

		public int value() {
			return status;
		}
		
		public String msgKey() {
			return I18NMsgPrefix + status;
		}
		
		public static enuStatus fromInt(int fromInt) {
			enuStatus result = UNDEFINED;
			for(enuStatus s : enuStatus.values()) {
				if(s.value() == fromInt)
					result = s;
			}
			return result;
		}
	}
	
	public String getMsg(enuStatus status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::getMsg";
		return Messages.getMsg(status.msgKey());
	} // public String getMsg
	
	public String getMsg(int status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::getMsg";
		return Messages.getMsg(I18NMsgPrefix+status);
	} // public String getMsg
	
	
	public boolean isNotProcessed(int status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isNotProcessed";
		return (enuStatus.NOT_PROCESSED.value() == status);
	} // public boolean isNotProcessed
	
	public boolean isNotProcessed(enuStatus status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isNotProcessed";
		return (enuStatus.NOT_PROCESSED == status);
	} // public boolean isNotProcessed
	
	
	public boolean isRunning(int status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isRunning";
		return (enuStatus.RUNNING.value() == status);
	} // public boolean isRunning
	
	public boolean isRunning(enuStatus status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isRunning";
		return (enuStatus.RUNNING == status);
	} // public boolean isRunning
	
	
	public boolean isFinished(int status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isFinished";
		return (enuStatus.FINISHED.value() == status);
	} // public boolean isFinished
	
	public boolean isFinished(enuStatus status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isFinished";
		return (enuStatus.FINISHED == status);
	} // public boolean isFinished
	
	
	public boolean isError(int status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isError";
		return (enuStatus.ERROR.value() == status);
	} // public boolean isError
	
	public boolean isError(enuStatus status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isError";
		return (enuStatus.ERROR == status);
	} // public boolean isError
	
	
	public boolean isIgnored(int status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isIgnored";
		return (enuStatus.IGNORED.value() == status);
	} // public boolean isIgnored
	
	public boolean isIgnored(enuStatus status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isIgnored";
		return (enuStatus.IGNORED == status);
	} // public boolean isIgnored
	
	
	public boolean isWaiting(int status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isWaiting";
		return (enuStatus.WAITING.value() == status);
	} // public boolean isWaiting
	
	public boolean isWaiting(enuStatus status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isWaiting";
		return (enuStatus.WAITING == status);
	} // public boolean isWaiting
	
	
	public boolean isDispatching(int status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isDispatching";
		return (enuStatus.DISPATCHING.value() == status);
	} // public boolean isDispatching
	
	public boolean isDispatching(enuStatus status) {
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::isDispatching";
		return (enuStatus.DISPATCHING == status);
	} // public boolean isDispatching
}
