/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model.objects;

import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import org.apache.log4j.Logger;

import com.sos.JSHelper.io.Files.JSTextFile;
import com.sos.VirtualFileSystem.Interfaces.ISOSVirtualFile;
import com.sos.VirtualFileSystem.shell.cmdShell;
import com.sos.scheduler.model.SchedulerObjectFactory;

/**
* \class JSObjJobChain
*
* \brief JSObjJobChain -
*
* \details
*
* \section JSObjJobChain.java_intro_sec Introduction
*
* \section JSObjJobChain.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 09.02.2011 14:37:58
 */

/**
 * @author oh
 *
 */

public class JSObjJobChain extends JobChain {

	public static final String	conNO				= "no";
	public static final String	conYES				= "yes";
	private final String		conClassName		= "JSObjJobChain";
	@SuppressWarnings("unused")
	private static final Logger	logger				= Logger.getLogger(JSObjJobChain.class);

	public final static String	fileNameExtension	= ".job_chain.xml";
	public static final String	conFileNameExtension4NodeParameterFile	= ".config.xml";

	public JSObjJobChain(final SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
		super.strFileNameExtension = fileNameExtension;
	}

	public JSObjJobChain(final SchedulerObjectFactory schedulerObjectFactory, final JobChain origOrder) {
		this(schedulerObjectFactory);
		setObjectFieldsFrom(origOrder);
	}

	public JSObjJobChain(final SchedulerObjectFactory schedulerObjectFactory, final ISOSVirtualFile pobjVirtualFile) {
		this(schedulerObjectFactory);
		super.objVirtualFile = pobjVirtualFile;
		loadObject();
	}

	public void loadObject() {
		JobChain objJobChain = (JobChain) unMarshal(super.objVirtualFile);
		setObjectFieldsFrom(objJobChain);
		setHotFolderSrc(super.objVirtualFile);
	}

	/**
	 *
	 * \brief setOrdersRecoverable
	 *
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsOrdersRecoverable
	 */
	public void setOrdersRecoverable(final boolean pflgIsOrdersRecoverable) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setOrdersRecoverable";
		if (canUpdate() && pflgIsOrdersRecoverable != getYesOrNo(this.getOrdersRecoverable())) {
			if (pflgIsOrdersRecoverable == true) {
				this.setOrdersRecoverable(conYES);
			}
			else {
				this.setOrdersRecoverable(conNO);
			}
			setDirty();
		}
	} // public void setOrdersRecoverable

	/**
	 *
	 * \brief setVisible
	 *
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsVisible
	 */
	public void setVisible(final boolean pflgIsVisible) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setVisible";
		if (canUpdate()) {
			if (pflgIsVisible == true) {
				this.setVisible(conYES);
			}
			else {
				this.setVisible(conNO);
			}
			setDirty();
		}
	} // public void setVisible

	/**
	 *
	 * \brief setDistributed
	 *
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsDistributed
	 */
	public void setDistributed(final boolean pflgIsDistributed) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setDistributed";

		if (canUpdate() && getYesOrNo(super.getDistributed()) != pflgIsDistributed) {
			if (pflgIsDistributed == true) {
				this.setDistributed(conYES);
			}
			else {
				this.setDistributed(conNO);
			}
			setDirty();
		}
	} // public void setDistributed

	@Override
	public String getObjectName() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getJobName";

		String name = this.getHotFolderSrc().getName();
		if (name == null) {
			name = "???";
		}
		else {
			name = name.substring(0, name.indexOf(JSObjJobChain.fileNameExtension));
			name = new File(name).getName();
		}

		return name;

	} // private String getJobName

	@Override
	public String getObjectNameAndTitle() {
		String strT = this.getObjectName();
		String strV = this.getTitle();
		if (strV != null && strV.isEmpty() == false) {
			strT += " - " + this.getTitle();
		}
		return strT;
	}

	@Override
	public void setName(final String pstrName) {
		if (canUpdate() == false) {
			return;
		}

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setName";
		// TODO Check for valid name
		String strOldName = getObjectName();
		if (strOldName.equals(pstrName) == false) {
			changeSourceName(pstrName);
			super.setName(pstrName);
			setDirty();
			// TODO rename filename ?
			//			getHotFolderSrc().rename(strNewName);
		}
	} // private void setName

	@Override
	public String getTitle() {
		String strT = "";
		if (title == null) {
			strT = getObjectName();
		}
		else {
			strT = title;
		}

		return strT;
	}

	@Override
	public void setTitle(final String pstrTitle) {
		if (canUpdate() == false) {
			return;
		}

		String strOldTitle = getTitle();
		if (strOldTitle.equals(pstrTitle) == false) {
			super.setTitle(pstrTitle);
			setDirty();
		}
	}

	public void setMaxorders(final String strMaxOrders) {
		if (canUpdate() == false) {
			return;
		}
		int maxOrders;
		try {
			maxOrders = Integer.parseInt(strMaxOrders);
			setMaxorders(maxOrders);
		}
		catch (NumberFormatException e) {
			maxOrders = 0;
		}
	}

	public void setMaxorders(final int maxOrders) {
		super.maxOrders = maxOrders;
		setDirty();
	}

	public boolean isDistributed() {
		return getYesOrNo(distributed);
	}

	public boolean isRecoverable() {
		return getYesOrNo(getOrdersRecoverable());
	}

	public boolean isVisible() {
		return getYesOrNo(getVisible());
	}

	public String getMaxOrders() {
		Integer intM = getmaxOrders();
		String strM = "";
		if (intM != null) {
			strM = String.valueOf(intM);
		}
		return strM;
	}

	public String createDOTFile() throws Exception {
		boolean flgCreateCluster = false;

		JSObjJobChain objChain = this;
		String strName = objChain.getName();
		if (strName == null) {
			strName = objChain.getObjectName();
		}
		String strFileName = "c:/temp/dottest/" + strName;
		JSTextFile objDotFile = new JSTextFile(strFileName + ".dot");
		objDotFile.deleteOnExit();

		// Get list of orders related to this JobChain

		/**
		Hashtable<String, JSObjOrder> tblOrders = new Hashtable<String, JSObjOrder>();
		for (JSObjBase objO : objSchedulerHotFolderFileList.getSortedFileList()) {
			if (objO instanceof JSObjOrder) {
				JSObjOrder objOrder = (JSObjOrder) objO;
				String strOrderName = objOrder.getJobChainName();
				if (strName.equalsIgnoreCase(strOrderName)) {
					tblOrders.put(strOrderName, objOrder);
				}
			}
		}
		*/

		objDotFile.WriteLine("digraph " + getQuoted(strName) + " {");
		objDotFile.WriteLine("rankdir = TB;");

		objDotFile.WriteLine("graph [");
		objDotFile.WriteLine("label = " + getQuoted(objChain.getTitle()));
		objDotFile.WriteLine("fontsize = 14");
		objDotFile.WriteLine("];");
		objDotFile.WriteLine("node [");
		objDotFile.WriteLine("fontsize = 10");
		objDotFile.WriteLine("shape = " + getQuoted("box"));
		objDotFile.WriteLine("style = " + getQuoted("rounded"));
		objDotFile.WriteLine("fontname = " + getQuoted("Arial"));
		objDotFile.WriteLine("];");

		Hashtable<String, JobChainNode> tblNodes = new Hashtable<String, JobChainNode>();
		objDotFile.WriteLine(getQuoted("start") + " [label = " + getQuoted("start" + ": " + strName) + ", shape = " + getQuoted("box") + ", style = "
				+ getQuoted("solid") + "];");
		objDotFile.WriteLine(getQuoted("end") + " [label = " + getQuoted("end" + ": " + strName) + ", shape = " + getQuoted("box") + ", style = "
				+ getQuoted("solid") + "];");

		/**
		for (JSObjOrder objOrder : tblOrders.values()) {
			objDotFile.WriteLine(getQuoted(objOrder.getObjectName()) + " [label = " + getQuoted("Order - " + objOrder.getObjectName()) + "];");
		}
		*/

		for (Object objO : objChain.getJobChainNodeOrFileOrderSinkOrJobChainNodeEnd()) {
			if (objO instanceof JobChainNode) {
				JobChainNode objNode = (JobChainNode) objO;
				String strState = objNode.getState();
				if (tblNodes.get(strState) == null) {
					tblNodes.put(strState, objNode);
					// "0" [label = "0: virtual start "];
					String strJobName = objNode.getJob();
					if (strJobName == null) {
						strJobName = "endNode";
					}
					String strT = strState;
					if (strState.equalsIgnoreCase(strJobName) == false) {
						strT = strState + ": " + strJobName;
					}
					objDotFile.WriteLine(getQuoted(strState) + " [label = " + getQuoted(strT) + "];");
					String strErrorState = objNode.getErrorState();
					if (strErrorState != null && tblNodes.get(strErrorState) == null) {
						tblNodes.put(strErrorState, objNode);
						objDotFile.WriteLine(getQuoted(strErrorState) + " [label = " + getQuoted(strErrorState)
								+ ", color=\"red\", fillcolor=\"yellow\", style=\"filled\", fontcolor=\"blue\"];");
					}
				}
			}
		}
		// TODO implement Method: getNodes()
		// TODO implement Method: getAllNodeNames()

		/**
		for (JSObjOrder objOrder : tblOrders.values()) {
			objDotFile.WriteLine(getQuoted(objOrder.getObjectName()) + " -> " + getQuoted("start"));
		}
		*/

		boolean flgStart = true;
		String strState = null;
		String strNextState = null;
		String strLastNextState = null;
		for (Object objO : objChain.getJobChainNodeOrFileOrderSinkOrJobChainNodeEnd()) {
			if (objO instanceof JobChainNode) {
				JobChainNode objNode = (JobChainNode) objO;

				strState = objNode.getState();

				if (flgStart == true) {
					flgStart = false;
					objDotFile.WriteLine(getQuoted("start") + " -> " + strState);
					if (flgCreateCluster) {
						objDotFile.WriteLine("subgraph cluster_0 {");
						objDotFile.WriteLine("    style=filled;");
						objDotFile.WriteLine("color=lightgrey;");
						objDotFile.WriteLine("node [style=filled,color=white];");
					}
				}
				strNextState = objNode.getNextState();
				if (strNextState != null) {
					objDotFile.WriteLine(getQuoted(strState) + " -> " + getQuoted(strNextState));
					strLastNextState = strNextState;
				}
				//						else {
				//							objDotFile.WriteLine(getQuoted(strState) + " -> " + getQuoted("end"));
				//						}
			}
		}

		objDotFile.WriteLine(getQuoted(strLastNextState) + " -> " + "end");
		if (flgCreateCluster) {
			objDotFile.WriteLine("label = \"Process\";");
			objDotFile.WriteLine("}");
		}

		/**
		 * create the links to the error-states.
		 */
		Hashtable<String, JobChainNode> tblErrNodes = new Hashtable<String, JobChainNode>();
		for (Object objO : objChain.getJobChainNodeOrFileOrderSinkOrJobChainNodeEnd()) {
			if (objO instanceof JobChainNode) {
				JobChainNode objNode = (JobChainNode) objO;

				strState = objNode.getState();

				String strErrorState = objNode.getErrorState();
				if (strErrorState != null) {
					objDotFile.WriteLine(getQuoted(strState) + " -> " + getQuoted(strErrorState) + " [style=\"dotted\", constraint=false]");
					tblErrNodes.put(strErrorState, objNode);
				}
				else {
				}
			}
		}

		if (flgCreateCluster) {
			objDotFile.WriteLine("subgraph cluster_1 {");
			objDotFile.WriteLine("    style=filled;");
			objDotFile.WriteLine("color=lightgrey;");
			objDotFile.WriteLine("node [style=filled,color=white];");
		}

		String strLastErrNode = "";
		for (JobChainNode objErrNode : tblErrNodes.values()) {
			String strErrNodeName = objErrNode.getErrorState();
			if (flgCreateCluster) {
				if (strLastErrNode.length() <= 0) {
					strLastErrNode = strErrNodeName;
				}
				else {
					objDotFile.WriteLine(getQuoted(strLastErrNode) + " -> " + getQuoted(strErrNodeName) + " [style=invis]");
					strLastErrNode = strErrNodeName;
				}
			}
			objDotFile.WriteLine(getQuoted(strErrNodeName) + " -> " + getQuoted("end"));
		}

		if (flgCreateCluster) {
			objDotFile.WriteLine("label = \"Error\";");
			objDotFile.WriteLine("}");
		}

		objDotFile.WriteLine("}");
		objDotFile.close();

		cmdShell objShell = new cmdShell();

		String strCommandString = String.format("dot.exe -x -T%1$s %2$s.dot > %2$s.%1$s", "jpg", strFileName);
		objShell.setCommand(strCommandString);
		objShell.run();

		return strFileName + ".jpg";
	}

	@Override
	public Integer getmaxOrders() {
		if (maxOrders == null) {
			return 0;
		}
		return maxOrders;
	}

	public List<FileOrderSink> getFileOrderSinkList() {
		List<FileOrderSink> objList = new ArrayList<FileOrderSink>();

		for (Object objO : this.getJobChainNodeOrFileOrderSinkOrJobChainNodeEnd()) {
			if (objO instanceof FileOrderSink) {
				objList.add((FileOrderSink) objO);
			}
		}

		return objList;
	}

	public List<FileOrderSource> getFileOrderSourceList() {
		List<FileOrderSource> objList = new ArrayList<FileOrderSource>();

		for (Object objO : this.getFileOrderSource()) {
			if (objO instanceof FileOrderSource) {
				objList.add((FileOrderSource) objO);
			}
		}

		return objList;
	}

	public List<JobChainNode> getJobChainNodeList() {
		List<JobChainNode> objList = new ArrayList<JobChainNode>();

		for (Object objO : this.getJobChainNodeOrFileOrderSinkOrJobChainNodeEnd()) {
			if (objO instanceof JobChainNode) {
				objList.add((JobChainNode) objO);
			}
		}

		return objList;
	}

	public List<JobChainNodeEnd> getJobChainNodeEndList() {
		List<JobChainNodeEnd> objList = new ArrayList<JobChainNodeEnd>();

		for (Object objO : this.getJobChainNodeOrFileOrderSinkOrJobChainNodeEnd()) {
			if (objO instanceof JobChainNodeEnd) {
				objList.add((JobChainNodeEnd) objO);
			}
		}

		return objList;
	}

}
