/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "spooler.h"

namespace sos {
namespace scheduler {

using namespace std;


Type_int_map Type_int_map::static_singleton;



string Object_call::obj_name() const 
{ 
    return S() << "(" << object()->obj_name() << ") <- " << call_name(); 
}


int Type_int_map::type_to_int(const type_info& t) {
    // Registriert den Typ, wenn nicht schon bekannt, und liefert eine ID
    Z_MUTEX(_mutex) {
        string id_string = id_of_type_info(t);
        stdext::hash_map<string,int>::iterator i = _map.find(id_string);
        if (i != _map.end()) {
            return i->second;
        } else {
            int id_int = _map.size();
            _map[id_string] = id_int;
            return id_int;
        }
    }
    z::throw_xc(Z_FUNCTION);
};

//Operation_holder::Operation_holder(Spooler* spooler) 
//    : _spooler(spooler) {}
//
//
//void Operation_holder::enqueue(Operation* o) {
//    cancel();
//    if (!o->at().is_never()) {
//        _spooler->enqueue_operation(o);
//        _operation = o;
//    }
//}
//
//
//void Operation_holder::cancel() {
//    if (_operation) {
//        _spooler->cancel_operation(_operation);
//        _operation = NULL;
//    }
//}
//
//
//Time Operation_holder::at() const {
//    return _operation? _operation->at() : Time::never;
//}
//


Typed_call_register::Typed_call_register(Spooler* spooler) 
    : _spooler(spooler) {}


Typed_call_register::~Typed_call_register() {
    Z_FOR_EACH(Map, _map, i) 
        cancel_entry(&i->second);
}


void Typed_call_register::enqueue_id(int id, Timed_call* o) {
    cancel_id(id);
    _map[id] = o;
    _spooler->enqueue_call(o);
}


void Typed_call_register::cancel_id(int id) {
    Map::iterator i = _map.find(id);
    if (i != _map.end())
        cancel_entry(&i->second);
}


void Typed_call_register::cancel_entry(ptr<Timed_call>* entry) {
    if (Timed_call* o = *entry) {
        _spooler->cancel_call(o);
        *entry = (Timed_call*)NULL;
    }
}


Time Typed_call_register::next_time() const {
    Time result = Time::never;
    Z_FOR_EACH_CONST(Map, _map, i) {
        if (const Timed_call* t = i->second)
            if (result < t->at()) result = t->at();
    }
    return result;
}

}}
